﻿using System;
namespace GSync
{
    /// <summary>
    /// Provides access to hash codes storage.
    /// </summary>
    public interface IHashCodesCacheManager
    {
        /// <summary>
        /// Get/set hash code by ID
        /// </summary>
        /// <param name="ID"></param>
        /// <returns></returns>
        CacheRecord this[string ID]
        {
            get;
            set;
        }
        /// <summary>
        /// Loads data from storage.
        /// </summary>
        void Load();
        /// <summary>
        /// Saves data to storage.
        /// </summary>
        void Save();

        void Clear();
    }
}